#ifndef BASISSTORE_H
#define BASISSTORE_H

#include <vector>

template< typename Solver >
struct BasisStore {
	typedef typename Solver::Basis Basis;
	std::vector<Basis> store;

	Basis get_basis( const unsigned int& i )
	{
		return store[i];
	}

	unsigned int push( Basis b )
	{
		store.push_back( b );
		return store.size() - 1;
	}

};

#endif
