#ifndef _GENERICTRAITS_H_
#define _GENERICTRAITS_H_


template< int num_solvers,
					typename Tree,
					typename Solver,
					typename InfeasibilityHandler,
					typename WorsenessHandler,
					typename IntegralityHandler,
					typename BasisStore >
struct GenericTraits {
	typedef typename Tree::Node Node;

	Tree tree;

	Solver solver[num_solvers];

	InfeasibilityHandler node_infeasible_notification;
	WorsenessHandler node_worse_notification;
	IntegralityHandler node_integral_notification;

	BasisStore basis_store;

	GenericTraits() 
		: node_infeasible_notification( tree, solver ),
			 node_worse_notification( tree, solver ),
			 node_integral_notification( tree, solver )
	{}

	bool lower_first( const int& i ) 
	{
		return solver[i].value_of( solver[i].get_candidate() ) < 0.5;
	}

};

#endif
