#ifndef _HEURISTICHANDLER_H_
#define _HEURISTICHANDLER_H_

#include <iostream>

template< class Tree, class Solver >
struct IdentityDefiner {
	
	Tree& tree;
	Solver& solver;

	IdentityDefiner( Tree& t, Solver& s ) : tree( t ), solver(s) {}

	template< typename Node >
	void operator()( Node* node )
	{
		std::vector<int> identity;
		int dim = solver.getDim();
		identity.resize(dim);
		for(int i = 0; i < dim; ++i)
			identity[i] = i;
		double value = solver.QAP_objective(identity);
		if(!tree.worse(value)){
			tree.new_best_solution(value);
			tree.commit_incumbent(identity);
		}
	}

};

template< class Tree, class Solver >
struct GilmoreLawlerHeuristic {

	Tree& tree;
	Solver& solver;

	GilmoreLawlerHeuristic( Tree& t, Solver& s ) : tree( t ), solver(s) {}

	template< typename Node >
	void operator()( Node* node )
	{
		//TODO
	}

};

#endif 
