#include "moseksolver.h"
#include "sdpsolver.h"
#include "sdptraits.h"
#include "branching.h"
#include "bbnode.h"
#include "bbtree.h"
#include "infeasibilityhandler.h"
#include "integralityhandler.h"
#include "heuristichandler.h"
#include "noop.h"
#include <iostream>
#include "basisstore.h"

using namespace std;

int main(int argc, char** argv) {

	if (argc < 2) {
		cerr << "Usage: " << argv[0] << " <filename> [swapDP]" << endl;
		exit(0);
	}

	const int num_solvers = 1;

	typedef SdpTraits<num_solvers, bbTree, mosekSolver, NoopHandler,
			NoopHandler, NotifyTreeOnPossiblyNewIncumbent<bbTree>,
			IdentityDefiner<bbTree, mosekSolver> > Traits;

	Traits traits;

	for (int i = 0; i < num_solvers; ++i) {
		if (argc > 2) {
			traits.solver[i].swapDandP = true;
		}
		traits.solver[i].read(argv[1], argv[2]);

	}
	traits.tree.root = new bbNode;
	traits.tree.num_nodes = 1;
	branching<num_solvers>(traits);

	cout << "created " << traits.tree.num_nodes << " nodes" << endl;
	cout << "best integral solution: " << traits.tree.bestKnownIntegralSolution
			<< endl;


	return 0;
}
